  struct TPAheader
{
	unsigned long	TPAversion; // 0x130, 0x140 or 0x150
	unsigned long	numSoundSamples;
	unsigned long	IDtableOffset;
	unsigned long	numCollisions; // usually zero in files other than Effects.tpa
	unsigned long	FoleyTableOffset; // points to EOF if no collisions
	unsigned long	numSoundIDs; // equal or greater than numSoundSamples
};



  struct TPAidHeader
{
	unsigned long	SoundID; // CRC-32 hash for sound name
	unsigned long	SampleOffset; // offset to Sample Table entry from beginning of file
	unsigned long	SampleLength; // Length of Sample Table entry in bytes
//	float	SampleDuration; // in seconds; Absent in v150 files
//	float	Attenuation; // in dB; Absent in v130 files
//	float	MasterVolume; // in dB; Absent in v130 files
};


  struct TPAsampleHeader
{
	unsigned long	magicNumber; // should always be 0x524F4257 (ASCII for 'R''O''B''W', stored backwards)
	unsigned long	CAUversion; // can be 100 (0x64) or 110 (0x6E)
	unsigned long	SampleDataOffset; // 0x20 in v100 files, 0x24 in v110 files if no captions present
	unsigned long	ADPCMblockLength;
	unsigned long	SampleDataLength; // size of stored data in bytes
	unsigned long	uncompressedDataLength; // what it takes up after being uncompressed
	unsigned long	sampleRate; // typical values are 11025, 22050, 44100 (CD quality)
	unsigned char   bitsPerSample;	// usually 8 or 16
	unsigned char	numChannels; // 1 = mono, 2 = stereo
	unsigned char   compressionType; // 0 = PCM (uncompressed), 1 = DVI/IMA ADPCM (compressed)
	unsigned char   flags;
//	unsigned long   captionsOffset; // only in v110 files, 0x00 if no captions, 0x24 if captions
};


  struct captionHeader
{
	unsigned long	captionBlockLength;
	unsigned long	numCaptionLines; // can't be 0
};


  struct captionLine
{
	unsigned long	lineDuration; // time to display this text in multiples of 200ms
	std::string	lineText; // 0-terminated text string
};


  struct transferFunctionTable
{
	float	maxVolume;
	float	minVolume;
	float	VolumeSlope;
	float	VolumeIntersection;
	float	maxPitch;
	float	minPitch;
	float	PitchSlope;
	float	PitchIntersection;
	float	Attenuation; // Attenuation in dB/m
//	float	minVelocity; // not present in v130 TPA files
};

  struct FoleyTableEntry
{
	unsigned long	SoundMaterial1Hash;
	unsigned long	SoundMaterial2Hash;
	unsigned long	numEffectSounds; // bits 0-6 can be 1 or 2, bit 7 indicates friction SFX
	float	minTimeDelay;
	float	lastTimeUsed;
	unsigned long	SoundEffect1Hash;	
	unsigned long	SoundEffect2Hash;	
	unsigned long	FrictionSoundEffectHash;	
//	transferFunctionTable SoundEffect1Table;
//	transferFunctionTable SoundEffect2Table;
//	transferFunctionTable FrictionSoundEffectTable;
};

